# Find Alazar

if(NOT TARGET Alazar::ATSApi)

set(SEARCH
    "${AlazarTech_DIR}"
    "/usr"
    "/usr/local"
    "C:/AlazarTech/ATS-GPU/*/base"
)

if(CMAKE_CL_64)
    set(ARCH "x64")
else(CMAKE_CL_64)
    set(ARCH "Win32")
endif(CMAKE_CL_64)


add_library(Alazar::ATSApi SHARED IMPORTED GLOBAL)

# includes
find_path("Alazar_ATSApi_INCLUDE_DIR" NAMES "AlazarApi.h" PATHS ${SEARCH} PATH_SUFFIXES "include")
set_property(TARGET Alazar::ATSApi PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${Alazar_ATSApi_INCLUDE_DIR}")

# imported library or shared object
find_library("Alazar_ATSApi_LIB_DEBUG" NAMES "ATSApi" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
find_library("Alazar_ATSApi_LIB_RELEASE" NAMES "ATSApi" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
if(WIN32)
    set_property(TARGET Alazar::ATSApi PROPERTY IMPORTED_IMPLIB_DEBUG "${Alazar_ATSApi_LIB_DEBUG}")
    set_property(TARGET Alazar::ATSApi PROPERTY IMPORTED_IMPLIB "${Alazar_ATSApi_LIB_RELEASE}")
endif(WIN32)
set_property(TARGET Alazar::ATSApi PROPERTY IMPORTED_LOCATION "${Alazar_ATSApi_LIB_RELEASE}")

if(${Alazar_ATSApi_LIB_RELEASE})
    message(STATUS "Found ATSApi: ${Alazar_ATSApi_LIB_RELEASE}")
endif()

add_library(Alazar::ATS-GPU SHARED IMPORTED GLOBAL)

# includes
find_path("Alazar_ATS-GPU_INCLUDE_DIR" NAMES "ATS_GPU.h" PATHS ${SEARCH} PATH_SUFFIXES "include")
set_property(TARGET Alazar::ATS-GPU PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${Alazar_ATS-GPU_INCLUDE_DIR}")

# imported library or shared object
find_library("Alazar_ATS-GPU_LIB_DEBUG" NAMES "ATS_GPU" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
find_library("Alazar_ATS-GPU_LIB_RELEASE" NAMES "ATS_GPU" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
if(WIN32)
    set_property(TARGET Alazar::ATS-GPU PROPERTY IMPORTED_IMPLIB_DEBUG "${Alazar_ATS-GPU_LIB_DEBUG}")
    set_property(TARGET Alazar::ATS-GPU PROPERTY IMPORTED_IMPLIB "${Alazar_ATS-GPU_LIB_RELEASE}")
endif(WIN32)
set_property(TARGET Alazar::ATS-GPU PROPERTY IMPORTED_LOCATION "${Alazar_ATS-GPU_LIB_RELEASE}")

if(${Alazar_ATS-GPU_LIB_RELEASE})
    message(STATUS "Found ATS-GPU: ${Alazar_ATS-GPU_LIB_RELEASE}")
endif()

add_library(Alazar::ATS-CUDA SHARED IMPORTED GLOBAL)

# includes
find_path("Alazar_ATS-CUDA_INCLUDE_DIR" NAMES "ATS_CUDA.h" PATHS ${SEARCH} PATH_SUFFIXES "include")
set_property(TARGET Alazar::ATS-CUDA PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${Alazar_ATS-CUDA_INCLUDE_DIR}")

# imported library or shared object
find_library("Alazar_ATS-CUDA_LIB_DEBUG" NAMES "ATS_CUDA" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
find_library("Alazar_ATS-CUDA_LIB_RELEASE" NAMES "ATS_CUDA" PATHS ${SEARCH} PATH_SUFFIXES "library/${ARCH}")
if(WIN32)
    set_property(TARGET Alazar::ATS-CUDA PROPERTY IMPORTED_IMPLIB_DEBUG "${Alazar_ATS-CUDA_LIB_DEBUG}")
    set_property(TARGET Alazar::ATS-CUDA PROPERTY IMPORTED_IMPLIB "${Alazar_ATS-CUDA_LIB_RELEASE}")
endif(WIN32)
set_property(TARGET Alazar::ATS-CUDA PROPERTY IMPORTED_LOCATION "${Alazar_ATS-CUDA_LIB_RELEASE}")

if(${Alazar_ATS-CUDA_LIB_RELEASE})
    message(STATUS "Found ATS-GPU: ${Alazar_ATS-CUDA_LIB_RELEASE}")
endif()

unset(ARCH)
unset(SUFFIX)

endif()
