#include <vortex-python/common.hpp>

#if defined(VORTEX_ENABLE_DAQMX)
#include <vortex/driver/daqmx.hpp>
#endif

void bind_driver_daqmx(py::module& root){    
#if defined(VORTEX_ENABLE_DAQMX)
    auto m = root.def_submodule("daqmx");
    
    {
        using C = vortex::daqmx::edge_t;
        auto c = py::enum_<C>(m, "Edge")
            .value("Rising", C::rising)
            .value("Falling", C::falling);
        c.export_values();
    }
    {
        using C = vortex::daqmx::terminal_t;
        auto c = py::enum_<C>(m, "Terminal")
            .value("Referenced", C::referenced)
            .value("Unreferenced", C::unreferenced)
            .value("Differential", C::differential)
            .value("Pseudodifferential", C::pseudodifferential);
        c.export_values();
    }
#endif
}

